SystemOrganization addCategory: #'AST-Interpreter-Core'!

WeakIdentityKeyDictionary subclass: #ASTCache
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

ASTCache class
	instanceVariableNames: 'default'!

ASTCache class
	instanceVariableNames: 'default'!

!ASTCache class methodsFor: 'accessing' stamp: 'CamilloBruni 2/17/2012 14:22'!
at: aCompiledMethod
	^ default at: aCompiledMethod! !

!ASTCache class methodsFor: 'accessing' stamp: 'CamilloBruni 2/17/2012 14:30'!
default
	^ default! !

!ASTCache class methodsFor: 'accessing' stamp: 'CamilloBruni 2/17/2012 14:30'!
default: anASTCache
	default := anASTCache.! !

!ASTCache class methodsFor: 'class initialization' stamp: 'CamilloBruni 2/20/2012 18:54'!
initialize
	default := self new.
	Smalltalk addToShutDownList: self.! !

!ASTCache class methodsFor: 'accessing' stamp: 'CamilloBruni 2/17/2012 14:27'!
reset
	default reset.! !

!ASTCache class methodsFor: 'system startup' stamp: 'CamilloBruni 2/17/2012 15:10'!
shutDown	
	self reset.! !

!ASTCache methodsFor: 'accessing' stamp: 'CamilloBruni 2/17/2012 14:32'!
at: aCompiledMethod
	^ self 
		at: aCompiledMethod
		ifAbsentPut: [ 
			aCompiledMethod parseTree annotateInClass: aCompiledMethod methodClass ]! !

!ASTCache methodsFor: 'initialize-release' stamp: 'CamilloBruni 2/20/2012 18:55'!
initialize: size
	super initialize: size.
	self registerForMethodChangeNotifications.! !

!ASTCache methodsFor: 'update' stamp: 'CamilloBruni 2/20/2012 19:06'!
methodEvent: anEvent
	anEvent isModified
		ifTrue: [ self removeKey: anEvent oldItem ifAbsent: []].
	anEvent isRemoved
		ifTrue: [ self removeKey: anEvent item ifAbsent: []].! !

!ASTCache methodsFor: 'initialize-release' stamp: 'CamilloBruni 2/20/2012 18:55'!
registerForMethodChangeNotifications.
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofSystemChangesOfItem: #method  
		using: #methodEvent:! !

!ASTCache methodsFor: 'accessing' stamp: 'CamilloBruni 2/17/2012 14:29'!
reset
	self removeAll! !

MessageNotUnderstood subclass: #RecursiveMessageNotUnderstood
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

Error subclass: #InterpretationError
	instanceVariableNames: 'cause'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!InterpretationError class methodsFor: 'signalling' stamp: 'CamilloBruni 12/9/2011 14:08'!
signalFor: aCauseError
	^ self new
		cause: aCauseError;
		signal! !

!InterpretationError methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:08'!
cause

	^ cause! !

!InterpretationError methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:08'!
cause: anObject
	
	cause := anObject! !

!InterpretationError methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/12/2011 14:29'!
isResumable
	^ true! !

Object subclass: #AIContext
	instanceVariableNames: 'closure temporaries arguments outerContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

AIContext subclass: #AIBlockContext
	instanceVariableNames: 'homeContext exceptionHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 20:52'!
exceptionHandler
	^ exceptionHandler! !

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 20:52'!
exceptionHandler: anExceptionHandler
	exceptionHandler := anExceptionHandler! !

!AIBlockContext methodsFor: 'testing' stamp: 'CamilloBruni 12/12/2011 14:19'!
hasExceptionHandler
	^ exceptionHandler isNil not! !

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:57'!
homeContext

	^ homeContext! !

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:57'!
homeContext: aContext

	homeContext := aContext! !

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 20:44'!
methodClass
	self flag: 'use the same closures everywhere..'.
	^ self outerContext methodClass! !

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 15:05'!
receiver
	^ self homeContext receiver! !

!AIBlockContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/12/2011 14:33'!
returnContext
	self flag: 'TODO: not sure if this is correct...'.
	^ self homeContext returnContext! !

AIBlockContext subclass: #AIRootContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!AIRootContext methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/9/2011 22:20'!
handleSignal: exception
	<reflective: #rootContextHandleSignal:message:>
	InterpretationError signal: exception! !

!AIRootContext methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/12/2011 14:19'!
hasExceptionHandler
	^ true! !

!AIRootContext methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/12/2011 15:34'!
outerContext
	^ outerContext ifNil: [ outerContext := AIRootContext new ].! !

!AIRootContext methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/12/2011 15:11'!
receiver
	^ self! !

!AIRootContext methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/12/2011 15:56'!
resume: aValue
	"<reflective: #escape:message:>"
	^ super resume: aValue! !

!AIRootContext methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/12/2011 15:32'!
returnContext
	^ self outerContext! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:35'!
arguments
	^ arguments! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:35'!
arguments: aCollection
	arguments := aCollection! !

!AIContext methodsFor: 'exception-handling' stamp: 'CamilloBruni 12/12/2011 14:42'!
cannotReturn: result to: homeContext
	"The receiver tried to return result to homeContext that no longer exists."

	^ BlockCannotReturn new
		result: result;
		deadHome: homeContext;
		signal! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:33'!
closure

	^ closure! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:33'!
closure: anObject
	
	closure := anObject! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 20:01'!
code
	^ self closure code! !

!AIContext methodsFor: 'st-compatibility' stamp: 'CamilloBruni 12/8/2011 14:45'!
contextTag
	^ self! !

!AIContext methodsFor: 'exception-handling' stamp: 'CamilloBruni 12/9/2011 16:31'!
findContextSuchThat: testBlock
	"Search self and my sender chain for first one that satisfies testBlock.  Return nil if none satisfy"

	| ctxt |
	
	ctxt := self.
	[ctxt isNil] whileFalse: [
		(testBlock value: ctxt) 
			ifTrue: [^ ctxt].
		ctxt := ctxt outerContext ].

	^ nil! !

!AIContext methodsFor: 'exception-handling' stamp: 'CamilloBruni 12/13/2011 15:07'!
findNextHandlerContextStarting
	"Return the next handler marked context, returning nil if there is none.  
	Search starts with self and proceeds up to nil."
	
	^ self findContextSuchThat: [ :ctxt| ctxt hasExceptionHandler ]! !

!AIContext methodsFor: 'exception-handling' stamp: 'CamilloBruni 12/13/2011 15:10'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."

	| result |
	
	(self exceptionHandler handles: exception)
		ifFalse: [ ^ self nextHandlerContext handleSignal: exception].

	exception privHandlerContext: self contextTag.
	
	"self tempAt: 3 put: false. " "disable self while executing handle block"
	
	result := self exceptionHandler handle: exception.
	
	self return: result.  "return from self if not otherwise directed in handle block"
! !

!AIContext methodsFor: 'testing' stamp: 'CamilloBruni 12/12/2011 14:20'!
hasExceptionHandler
	^ false! !

!AIContext methodsFor: 'initialize-release' stamp: 'CamilloBruni 12/5/2011 18:08'!
initialize
	self flag: 'for now the easies solution'.
	temporaries := SmallDictionary new! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/12/2011 14:57'!
isDead
	self flag: 'TODO:'.
	^ false! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 19:36'!
methodClass
	^ closure methodClass! !

!AIContext methodsFor: 'exception-handling' stamp: 'CamilloBruni 12/9/2011 16:27'!
nextHandlerContext

	^ self outerContext findNextHandlerContextStarting! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:33'!
outerContext

	^ outerContext! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:33'!
outerContext: anObject
	
	outerContext := anObject! !

!AIContext methodsFor: 'continuation' stamp: 'CamilloBruni 12/12/2011 16:07'!
resume: value
	"Unwind thisContext to self and resume with value as result of last send.  Execute unwind blocks when unwinding.  ASSUMES self is a sender of thisContext"

	| ctxt unwindBlock |
	self isDead 
		ifTrue: [self cannotReturn: value to: self].
		
"	ctxt := thisContext.
	[	ctxt := ctxt findNextUnwindContextUpTo: self.
		ctxt isNil
	] whileFalse: [
		(ctxt tempAt: 2) ifNil:[
			ctxt tempAt: 2 put: true.
			unwindBlock := ctxt tempAt: 1.
			thisContext terminateTo: ctxt.
			unwindBlock value].
	]."

	thisContext terminateTo: self value: value.
! !

!AIContext methodsFor: 'continuation' stamp: 'CamilloBruni 12/12/2011 16:33'!
return: value
	"Unwind thisContext to self and return value to self's sender.  Execute any unwind blocks while unwinding.  ASSUMES self is a sender of thisContext"

	self returnContext 
		ifNil: [self cannotReturn: value to: self returnContext].
		
	self resume: value! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 17:52'!
tempNamed: aName
	self temporaries 
		at: aName 
		ifPresent: [ :value| ^ value].
	
	self outerContext 
		ifNil: [ Error signal: 'Could not find temp named "', aName , '"'].
		
	^ self outerContext tempNamed: aName.! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 17:52'!
tempNamed: aName put: aValue
	(self temporaries includesKey: aName)
		ifTrue: [ ^ self temporaries at: aName put: aValue ].
	
	self outerContext 
		ifNil: [ Error signal: 'Could not find temp named "', aName , '"'].
	
	^ self outerContext tempNamed: aName put: aValue
		! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 18:12'!
temporaries
	^ temporaries ifNil: [ temporaries := SmallDictionary new]! !

!AIContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 15:23'!
temporaries: aNameCollection
	aNameCollection do: [ :aVarName|
		self temporaries at: aVarName put: nil ].! !

!AIContext methodsFor: 'continuation' stamp: 'CamilloBruni 12/12/2011 16:14'!
terminateTo: previousContext value: aReturnValue
	"Terminate all the Contexts between me and previousContext, if previousContext is on my Context stack. Make previousContext my sender."

	<reflective: #contextTerminateTo:message:>
	
	PrimitiveFailed signal.
	! !

AIContext subclass: #AIMethodContext
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!AIMethodContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 20:04'!
homeContext
	^ self returnContext! !

!AIMethodContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:33'!
receiver

	^ receiver! !

!AIMethodContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 17:33'!
receiver: anObject
	
	receiver := anObject! !

!AIMethodContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 20:05'!
returnContext
	^ self outerContext! !

!AIMethodContext methodsFor: 'accessing' stamp: 'CamilloBruni 12/12/2011 15:51'!
returnContext: aContext
	^ self outerContext: aContext! !

Object subclass: #ASTClosure
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

ASTClosure subclass: #ASTBlockClosure
	instanceVariableNames: 'homeContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!ASTBlockClosure methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:47'!
accept: visitor
	^ visitor visitBlockClosure: self! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/12/2011 14:12'!
cull: anArg
	^ self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: anArg]
	! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/12/2011 14:12'!
cull: firstArg cull: secondArg
	^ self numArgs < 2 
		ifTrue: [self cull: firstArg]
		ifFalse: [self value: firstArg value: secondArg]
	! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/12/2011 14:12'!
cull: firstArg cull: secondArg cull: thirdArg
	^ self numArgs < 3 
		ifTrue: [self cull: firstArg cull: secondArg]
		ifFalse: [self value: firstArg value: secondArg value: thirdArg]
	! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/12/2011 14:12'!
cull: firstArg cull: secondArg cull: thirdArg cull: fourthArg
	"Execute the receiver with four or less arguments. Check cull:cull: for examples"
	
	^ self numArgs < 4 
		ifTrue: [self cull: firstArg cull: secondArg cull: thirdArg]
		ifFalse: [self value: firstArg value: secondArg value: thirdArg value: fourthArg]
	! !

!ASTBlockClosure methodsFor: 'exception' stamp: 'CamilloBruni 12/13/2011 15:31'!
ensure: aBlock
	"Evaluate a termination block after evaluating the receiver, regardless of
	 whether the receiver's evaluation completes."
	
	<reflective: #blockClosureEnsure:message:>
	PrimitiveFailed signal! !

!ASTBlockClosure methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:53'!
homeContext

	^ homeContext! !

!ASTBlockClosure methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:53'!
homeContext: aContext

	homeContext := aContext! !

!ASTBlockClosure methodsFor: 'exception' stamp: 'CamilloBruni 12/12/2011 16:13'!
on: exception do: aBlock
	<reflective: #blockClosureOnDo:message:>
	PrimitiveFailed signal! !

!ASTBlockClosure methodsFor: 'exception' stamp: 'CamilloBruni 12/13/2011 15:20'!
onDNU: selector do: handleBlock
	"Catch MessageNotUnderstood exceptions but only those of the given selector (DNU stands for doesNotUnderstand:)"

	^ self on: MessageNotUnderstood do: [:exception |
		exception message selector = selector
			ifTrue: [handleBlock cull: exception]
			ifFalse: [exception pass]
	  ]! !

!ASTBlockClosure methodsFor: 'accessing' stamp: 'CamilloBruni 12/9/2011 14:53'!
returnContext

	^ homeContext returnContext! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:16'!
value
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array new: 0)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg value: otherArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg with: otherArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg value: otherArg value: anotherArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg with: otherArg with: anotherArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg value: otherArg value: anotherArg value: yetAnotherArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg with: otherArg with: anotherArg with: yetAnotherArg)! !

!ASTBlockClosure methodsFor: 'exception' stamp: 'CamilloBruni 12/13/2011 15:23'!
valueNoContextSwitch
	"An exact copy of BlockClosure>>value except that this version will not preempt
	 the current process on block activation if a higher-priority process is runnable.
	 Primitive. Essential."
	"<primitive: 221>
	self numArgs ~= 0 ifTrue:
		[self numArgsError: 0].
	self primitiveFailed"
	^ self value! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:14'!
valueWithArguments: arguments
	<reflective: #blockClosureValueWithArguments:message:>
	PrimitiveFailed signal! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:50'!
whileFalse
	self value ifFalse: [ self whileFalse ]! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:51'!
whileFalse: aBlock
	^ self value 
		ifFalse: [ 
			aBlock value. 
			self whileFalse: aBlock ]! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:50'!
whileTrue
	self value ifTrue: [ self whileTrue ]! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:50'!
whileTrue: aBlock
	^ self value
		ifTrue: [ 
			aBlock value. 
			self whileTrue: aBlock ]! !

!ASTClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:47'!
code

	^ code! !

!ASTClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:47'!
code: anObject
	
	code := anObject! !

!ASTClosure methodsFor: 'accessing' stamp: 'CamilloBruni 12/12/2011 14:15'!
numArgs
	^ self code arguments size! !

!ASTClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 10/5/2011 17:47'!
valueWithPossibleArgs: anArray
	| numArgs |
	numArgs := self numArgs.
	numArgs = 0
		ifTrue: [ ^ self value ].
	numArgs = anArray size
		ifTrue: [ ^ self valueWithArguments: anArray ].
	numArgs > anArray size
		ifTrue: [ ^ self valueWithArguments: anArray , (Array new: numArgs - anArray size) ].
	^ self valueWithArguments: (anArray copyFrom: 1 to: numArgs)! !

ASTClosure subclass: #ASTMethodClosure
	instanceVariableNames: 'host selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!ASTMethodClosure methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:47'!
accept: visitor
	^ visitor visitMethodClosure: self! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
host

	^ host! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
host: anObject
	
	host := anObject! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
selector

	^ selector! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
selector: anObject
	
	selector := anObject! !

Object subclass: #ASTInterpreter
	instanceVariableNames: 'context gotoContext returnBlock exceptionBlock primitiveFailed currentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/13/2011 16:15'!
acceptAssignmentNode: anAssignmentNode
	| value variable |
	
	value := self interpret: anAssignmentNode value.
	variable := anAssignmentNode variable.
	variable binding accept: self assign: value. 
	
	^ value! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/9/2011 14:52'!
acceptBlockNode: aBlockNode
	^ ASTBlockClosure new
		homeContext: self context;
		code: aBlockNode! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/13/2011 16:15'!
acceptCascadeNode: aCascadeNode
	| receiver lastResult |
	
	receiver := self interpret: aCascadeNode receiver.
	
	aCascadeNode messages do: [ :aMessageNode|
		lastResult := self acceptMessageNode: aMessageNode receiver: receiver.
		self ifSkip: [ ^ lastResult]].
	
	^ lastResult! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:38'!
acceptLiteralArrayNode: aNode
	^ aNode value! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:13'!
acceptLiteralNode: aLiteralNode
	^ aLiteralNode value! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/13/2011 16:15'!
acceptMessageNode: aMessageNode
	| receiver |

	receiver := self interpret: aMessageNode receiver.
	
	^ self acceptMessageNode: aMessageNode receiver: receiver.! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/13/2011 16:15'!
acceptMessageNode: aMessageNode receiver: receiver
	| arguments message lookUpClass|
	
	arguments := (aMessageNode arguments 
						collect: [ :argument| |arg|
							arg := (self interpret: argument).
							self ifSkip: [ ^ arg ].
							arg ]) asArray.
						
	message := Message selector: aMessageNode selector arguments: arguments.
	
	lookUpClass := aMessageNode isSuperSend 
						ifFalse: [ self classOf: receiver ]
						ifTrue: [ self currentMethodClass superclass ].
	
	^ self
		send: message
		to: receiver
		class: lookUpClass
		for: aMessageNode! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/13/2011 16:15'!
acceptReturnNode: aReturnNode
	| returnValue |
	
	returnValue := self interpret: aReturnNode value.
	
	self ifSkip: [ ^ returnValue ].
	
	self assert: gotoContext == false.
	gotoContext := context returnContext.
	
	^ returnValue! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/6/2011 15:51'!
acceptSelfNode: aSelf
	^ self currentSelf! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/13/2011 16:15'!
acceptSequenceNode: aSequenceNode
	| lastResult |
	 
	aSequenceNode statements do: [ :statement|
		lastResult := self interpret: statement.
		self ifSkip: [ ^ lastResult ]].
	
	self updateGotoContext.
		
	^ lastResult! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 19:31'!
acceptSuperNode: aSelf
	^ self currentSelf! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 15:14'!
acceptThisContextNode: thisContextNode
	^ self context! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 15:24'!
acceptVariableNode: aVariableNode
	^ aVariableNode binding readWith: self ! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/13/2011 16:01'!
blockClosureEnsure: aBlockClosure message: aMessage
	| result ensureBlockReturnValue firstGotoContext |
	
	"evaluate the block without arguments"
	result := self blockClosureValue: aBlockClosure. 
	firstGotoContext := gotoContext.
	gotoContext := false.
	
	"evluate the passed in ensure block"
	ensureBlockReturnValue := self blockClosureValue: aMessage arguments first.
	self isExplicitelyReturning
		ifTrue: [ ^ ensureBlockReturnValue ]
		ifFalse: [ gotoContext := firstGotoContext ].
	
	^ result! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/13/2011 15:05'!
blockClosureOnDo: aBlockClosure message: aMessage
	| block result returnContext |
	
	block := aBlockClosure code.
	
	self assert: aMessage numArgs = 2.


	returnContext := context.
	self blockContextFor: aBlockClosure message: aMessage.
	context exceptionHandler: (ExceptionHandler forMessage: aMessage).
	
	result := self interpretBlock: block.
	
	context := returnContext.
	^ result! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/13/2011 15:42'!
blockClosureValue: aBlockClosure
	^ self blockClosureValue: aBlockClosure message: (Message selector: #value)! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/12/2011 14:15'!
blockClosureValue: aBlockClosure message: aMessage
	| block result returnContext |
	
	block := aBlockClosure code.
	
	self assert: aBlockClosure numArgs = aMessage numArgs.
	block size = 0 ifTrue: [ ^ nil ].
	
	returnContext := context.
	self blockContextFor: aBlockClosure message: aMessage.
	
	result := self interpretBlock: block.
	
	context := returnContext.
	^ result! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/5/2011 16:20'!
blockClosureValueWithArguments: aBlockClosure message: aMessage
	^ self blockclosureValue: aBlockClosure message: (aMessage at: 1)! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 12/9/2011 14:59'!
blockContextFor: aBlockClosure message: aMessage
	| block size |
	
	block := aBlockClosure code.
	size := block allDefinedVariables size.
	
	"size = 0 
		ifTrue: [ ^ context := aBlockClosure returnContext ]."
	
	context := AIBlockContext new
		homeContext: aBlockClosure homeContext;
		outerContext: context;
		closure: aBlockClosure;
		arguments: aMessage arguments;
		temporaries: block temporaryNames.! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:24'!
classOf: anObject
	^ anObject class! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/5/2011 18:38'!
compile: aString
	| ast |
	ast := RBParser parseExpression: aString.
	ast annotateInClass: ProtoObject.
	^ ast! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 10/6/2011 15:53'!
context
	^ context! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 20:14'!
context: aContext
	context := aContext! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/12/2011 16:17'!
contextTerminateTo: aContext message: aMessage
	
	gotoContext := aMessage arguments first.
	^ aMessage arguments second
	! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 00:23'!
currentMethodClass
	^ context methodClass! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 16:02'!
currentSelf
	^ self context receiver! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/12/2011 14:53'!
escape: aClosure message: aMessage
	"avoid interpreting this message in the interpreter"
	self halt.! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/5/2011 20:43'!
ifSkip: aReturnBlock
	gotoContext == false ifTrue: [ ^ self ].
		
	aReturnBlock value.! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/13/2011 16:16'!
interpret: anASTNode

	currentNode := anASTNode.
	
	^ anASTNode acceptVisitor: self.! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/13/2011 16:14'!
interpretBlock: block
	^  self interpret: block body! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/13/2011 16:14'!
interpretMethod: method
	^ self interpret: method body! !

!ASTInterpreter methodsFor: 'initialization' stamp: 'CamilloBruni 12/5/2011 20:44'!
intialize
	super initialize.
	gotoContext := false.! !

!ASTInterpreter methodsFor: 'method-evaluation' stamp: 'CamilloBruni 12/13/2011 15:03'!
invokeMethod: aClosure on: receiver message: aMessage
	| result |
	
	self assert: aClosure numArgs = aMessage numArgs.
	aClosure size = 0 
		ifTrue: [ ^ receiver ].
	
	self
		methodContextFor: aClosure
		receiver: receiver
		message: aMessage.
		
	FileStream stderr 
		nextPutAll: (((self currentSelf class name, ':') padded: #right to: 20 with: $ ), aClosure printString); cr.
	"self halt."
	result := self interpretMethod: aClosure code.
	
	self isExplicitelyReturning 
		ifFalse: [ result := self currentSelf ].
		
	self popContext.

	^ result! !

!ASTInterpreter methodsFor: 'method-evaluation' stamp: 'CamilloBruni 12/12/2011 16:44'!
invokePrimitiveMethod: aCompiledMethod on: receiver message: aMessage
	| result |
	
	self flag: 'TODO: should track the tower of interpreters properly...'.
	primitiveFailed := false.
	
	result := receiver tryPrimitive: aCompiledMethod primitive withArgs: aMessage arguments.
	result = ContextPart primitiveFailToken ifFalse: [ ^ result ].
	
	"primitive failed"
	^ self
		invokeMethod: aCompiledMethod 
		on: receiver 
		message: aMessage! !

!ASTInterpreter methodsFor: 'method-evaluation' stamp: 'CamilloBruni 12/9/2011 22:22'!
invokeReflectiveMethod: aClosure on: receiver message: aMessage
	| annotation selector |
	
	annotation := aClosure pragmaAt: #reflective:.
	selector := annotation arguments first.
	
	(self respondsTo: selector) ifTrue: [
		^ self 
			perform: selector 
			withArguments: (Array with: receiver with: aMessage)].
		
	self halt.
	
	^ self invokeMethod: aClosure on: receiver message: aMessage! !

!ASTInterpreter methodsFor: 'testing' stamp: 'CamilloBruni 12/8/2011 18:27'!
isExplicitelyReturning
	^ gotoContext ~= false! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:27'!
lookupSelector: selector in: class
	| currentClass |
	currentClass := class.
	[ currentClass isNil ] whileFalse: [ 
			currentClass methodDict at: selector ifPresent: [ :method | ^ method ].
			currentClass := currentClass superclass ].
	^ nil! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 12/13/2011 15:03'!
methodContextFor: aCompiledMethod receiver: receiver message: aMessage

	context := AIMethodContext new
					receiver: receiver;
					outerContext: context;
					closure: aCompiledMethod;
					arguments: aMessage arguments;
					temporaries: aCompiledMethod code temporaryNames;
					yourself.! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/8/2011 18:25'!
popContext
	context := context outerContext.
	
	self updateGotoContext.! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 18:23'!
readArgumentAt: index named: aName
	^ self context arguments at: index! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/13/2011 15:06'!
readArgumentAt: index node: aVariableNode
	| variableContext |
	
	variableContext := self context.
	
	[ variableContext code = aVariableNode binding scope node ] 
		whileFalse: [
				variableContext := variableContext homeContext.
				self assert: variableContext isNil not ].
			
	^ variableContext arguments at: index! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 15:29'!
readArgumentNamed: aName
	^ self context tempNamed: aName! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 15:22'!
readInstVarAt: index named: name
	^ self currentSelf instVarAt: index! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 18:46'!
readTemporaryAt: index named: name
	^ context tempNamed: name! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:27'!
recursiveDoesNotUnderstand: aMessage on: receiver
	^ RecursiveMessageNotUnderstood new
		receiver: receiver;
		cls: receiver class;
		message: aMessage;
		signal! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 12/5/2011 20:44'!
resetContext: aContext
	context := aContext.
	gotoContext :=  false.! !

!ASTInterpreter methodsFor: 'reflective' stamp: 'CamilloBruni 12/12/2011 15:54'!
rootContextHandleSignal: aRootContext message: aMessage
	^ InterpretationError signalFor: aMessage arguments first.! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:24'!
send: aMessage to: receiver
	^ self
		send: aMessage
		to: receiver
		class: (self classOf: receiver)! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 12/5/2011 19:54'!
send: aMessage to: receiver class: class
	| method |
	
	method := self lookupSelector: aMessage selector in: class.
	method ifNil: [ ^ self sendDoesNotUnderstandFor: aMessage to: receiver ].
	
	^ method
		accept: self
		on: receiver
		message: aMessage! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 12/7/2011 18:40'!
send: aMessage to: receiver class: class for: aSend
	| method |
	
	method := self lookupSelector: aMessage selector in: class.
	method ifNil: [ ^ self sendDoesNotUnderstandFor: aMessage to: receiver ].
	
	^ method
		accept: self 
		on: receiver
		message: aMessage! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 12/13/2011 15:05'!
sendDoesNotUnderstandFor: aMessage to: receiver
	| dnu |
	
	aMessage selector = #doesNotUnderstand:
		ifTrue: [ 
			self halt.
			^ self recursiveDoesNotUnderstand: (aMessage at: 1) on: receiver ].
		
	dnu := Message selector: #doesNotUnderstand: argument: aMessage.
	^ self send: dnu to: receiver! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/8/2011 18:25'!
updateGotoContext

	gotoContext = context
		ifTrue: [ gotoContext := false ].! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 15:23'!
write: aValue at: index named: name
	^ self currentSelf instVarAt: index put: aValue! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 18:45'!
write: aValue temporaryAt: index named: name
	^ context tempNamed: name put: aValue! !

Object subclass: #ExceptionHandler
	instanceVariableNames: 'block exception enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Core'!

!ExceptionHandler class methodsFor: 'instance-creation' stamp: 'CamilloBruni 12/11/2011 18:46'!
forMessage: aMessage
	^ self 
		on: aMessage arguments first
		do: aMessage arguments second! !

!ExceptionHandler class methodsFor: 'instance-creation' stamp: 'CamilloBruni 12/12/2011 14:07'!
on: anException do: aBlock
	^ self new
		exception: anException;
		block: aBlock;
		yourself! !

!ExceptionHandler methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 15:47'!
block

	^ block! !

!ExceptionHandler methodsFor: 'accessing' stamp: 'CamilloBruni 12/8/2011 15:48'!
block: aBlock
	
	block := aBlock! !

!ExceptionHandler methodsFor: 'accessing' stamp: 'CamilloBruni 12/13/2011 15:08'!
enabled
	^ enabled! !

!ExceptionHandler methodsFor: 'accessing' stamp: 'CamilloBruni 12/12/2011 14:10'!
exception

	^ exception! !

!ExceptionHandler methodsFor: 'accessing' stamp: 'CamilloBruni 12/12/2011 14:09'!
exception: anException

	exception := anException! !

!ExceptionHandler methodsFor: 'exception-handling' stamp: 'CamilloBruni 12/13/2011 15:10'!
handle: anError
	| value |
	self flag: 'TODO:do the ensure magic here..'.
	enabled := false.
	value := self block cull: anError.
	enabled := true.
	^ value! !

!ExceptionHandler methodsFor: 'testing' stamp: 'CamilloBruni 12/13/2011 15:07'!
handles: anError

	^ self enabled and: [ self exception handles: anError ]! !

!ExceptionHandler methodsFor: 'initialization' stamp: 'CamilloBruni 12/13/2011 15:07'!
initialize
	super initialize.
	enabled := true.! !
ASTCache initialize!
